
#include "graphical_defs.h"
#include "lang.h"

// static char police9x15[9]= "9x15bold";
// static int lgpolice9x15 = 10; // size(police9x15)+1

static Pixel
GET_XCOLOR (Widget w, char *vcolor)
{
  char *color_name;
  XColor xcolor, unused;
  Colormap cmap = DefaultColormapOfScreen (XtScreen (w));

  if (XAllocNamedColor (XtDisplay (w), cmap, vcolor, &xcolor, &unused))
    return xcolor.pixel;
  return 0;
}

static Pixel redColor, whiteColor, yellowColor, blueColor, blackColor, greenColor;

static void
colors_init (Widget w)
{
  redColor = GET_XCOLOR (w, "red");
  whiteColor = GET_XCOLOR (w, "white");
  yellowColor = GET_XCOLOR (w, "yellow");
  blueColor = GET_XCOLOR (w, "cyan" /* "blue" */ );
  greenColor = GET_XCOLOR (w, "green");
  blackColor = GET_XCOLOR (w, "black");
}

/* Writing a string on a widget */
void
putlabel (Widget w, char *c)
{
  XmString str;
  Arg al[1];
  int ac = 0;
  str = XmStringCreateLtoR (c, XmSTRING_DEFAULT_CHARSET);
  (void) XtSetArg (al[ac], XmNlabelString, str);
  ac++;
  (void) XtSetValues (w, al, ac);
  (void) XmStringFree (str);
}


static Widget
make_label1 (char *nom, Widget pere, int h, int label_width)
{
  return XtVaCreateManagedWidget (nom, xmLabelWidgetClass, pere,
				  XmNlabelString, XmStringCreateLtoR (nom, XmSTRING_DEFAULT_CHARSET), XmNwidth, label_width, XmNheight, h, NULL);
}

static Widget
make_label (char *nom, Widget pere, int h)
{
  return make_label1 (nom, pere, h, LABEL_WIDTH);
}

static Widget
make_button (char *nom, Widget pere, int bordWidth)
{
  return (XtVaCreateManagedWidget (nom, xmPushButtonWidgetClass, pere,
				   XmNwidth, BUTTON_WIDTH,
				   XmNborderWidth, bordWidth, XmNlabelString, XmStringCreateLtoR (nom, XmSTRING_DEFAULT_CHARSET), NULL));
}


static Widget
make_button1 (char *nom, Widget pere, int bordWidth, int label_width)
{
  return (XtVaCreateManagedWidget (nom, xmPushButtonWidgetClass, pere,
				   XmNwidth, label_width,
				   XmNborderWidth, bordWidth, XmNlabelString, XmStringCreateLtoR (nom, XmSTRING_DEFAULT_CHARSET), NULL));
}


#include "pace_box.c"
#include "left_box.c"
#include "right_box.c"

/*------------------------------------------------------------------------------
  Creating the main window.
  ------------------------------------------------------------------------------*/
static void
mk_main_window (Widget toplevel)
{
  Widget pace, left, right, appli_widg, cadre_widg, frame_widg;

  colors_init (toplevel);

  cadre_widg = XtVaCreateManagedWidget ("cadre", xmMainWindowWidgetClass, toplevel, NULL);
  frame_widg = XtVaCreateManagedWidget ("frame", xmFormWidgetClass, cadre_widg,
					XmNwidth, DRAWING_AREA_WIDTH_PACE, XmNheight, DRAWING_AREA_HEIGHT_PACE + 2 * DRAWING_AREA_HEIGHT, NULL);
  pace = XtVaCreateManagedWidget ("pBOX", xmFormWidgetClass, frame_widg,
				  XmNborderWidth, 0,
				  XmNwidth, DRAWING_AREA_WIDTH_PACE,
				  XmNheight, DRAWING_AREA_HEIGHT_PACE,
				  XmNtopAttachment, XmATTACH_FORM, XmNleftAttachment, XmATTACH_FORM, XmNrightAttachment, XmATTACH_FORM, NULL);
  //  XtVaSetValues(pace, XtVaTypedArg, XmNfontList, XmRString, police9x15, lgpolice9x15, NULL);

  left = XtVaCreateManagedWidget ("LBOX", xmFormWidgetClass, frame_widg,
				  XmNwidth, DRAWING_AREA_WIDTH,
				  XmNleftAttachment, XmATTACH_FORM,
				  XmNtopAttachment, XmATTACH_WIDGET, XmNtopWidget, pace, XmNbottomAttachment, XmATTACH_FORM, NULL);
  //  XtVaSetValues(left, XtVaTypedArg, XmNfontList, XmRString, police9x15, lgpolice9x15, NULL);

  right = XtVaCreateManagedWidget ("RBOX", xmFormWidgetClass, frame_widg,
				   XmNwidth, DRAWING_AREA_WIDTH,
				   XmNrightAttachment, XmATTACH_FORM,
				   XmNtopAttachment, XmATTACH_WIDGET, XmNtopWidget, pace,
				   XmNleftAttachment, XmATTACH_WIDGET, XmNleftWidget, left, XmNbottomAttachment, XmATTACH_FORM, NULL);
  //  XtVaSetValues(right, XtVaTypedArg, XmNfontList, XmRString, police9x15, lgpolice9x15, NULL);
  PACE_BOX (pace);
  RIGHT_BOX (right);
  LEFT_BOX (left);
}
