process VTMEM_WITHOUT_DUPL =
     { integer NUL_CODE, LIN_CODE, TICK_NUMBER, FRONT_NUMBER, TICK_HEIGHT, DELTA, TICK_WIDTH, ESP_HEIGHT, STRING_HEIGHT, MIN_A, MAX_A; }
     ( ? event HE;
     )
   (| (| MEM_WITHOUT_DUPL{MIN_A}
       | CONTEXT{NUL_CODE, LIN_CODE}
       | SCREEN{TICK_NUMBER, FRONT_NUMBER, TICK_HEIGHT, DELTA, TICK_WIDTH, ESP_HEIGHT, STRING_HEIGHT, MIN_A, MAX_A}
       | BACK{}
       |)/ V2, V1, C2, C1, HVISU, A, H_0, Y, X, READ_ACCEPT, DIRECT_READ_ACCEPT |)
   where 
   use CONTEXT_LIB, SCREEN_LIB; 
   process BACK =
        ( ? integer Y; 
            integer X;
          ! event HVISU; 
            boolean C1; 
            boolean C2; 
            integer V1; 
            integer V2;
        )
      (| HVISU := X ^+ Y
       | C1 := ^X
       | C2 := ^Y
       | V1 := X
       | V2 := Y
       |)
   ; 
   process CONTEXT =
        { integer NUL_CODE, LIN_CODE; }
        ( ? boolean DIRECT_READ_ACCEPT; 
            boolean READ_ACCEPT; 
            integer Y; 
            event HE;
          ! event H_0; 
            integer A;
        )
      (| (| S_PACE_MAKER{NUL_CODE, LIN_CODE}
          | (| H := HES
             | SCAN{}
             |) where event H; end
          |)/ HES |)
      where 
      process SCAN =
           ( ? boolean DIRECT_READ_ACCEPT; 
               boolean READ_ACCEPT; 
               integer Y; 
               event H;
             ! integer A;
           )
         (| CA := GETCSIG(H, RCA())
          | A := GETISIG([:CA], RA())
          | CY := GETCSIG(H, RCY())
          | Y ^= [:CY] when DIRECT_READ_ACCEPT
          | READ_ACCEPT ^= CY
          |)
         where 
         boolean CA, CY; 
         process GETISIG =
              ( ? event H; 
                  integer V_ON;
                ! integer _ON_;
              )
            (| H ^= V_ON
             | _ON_ := V_ON
             |)
         ; 
         process RA =
              ( ! integer A;
              )
         
         ; 
         process GETCSIG =
              ( ? event H; 
                  boolean C_ON;
                ! boolean _ON_;
              )
            (| H ^= C_ON
             | _ON_ := C_ON
             |)
         ; 
         process RCA =
              ( ! boolean CA;
              )
         
         ; 
         process RCY =
              ( ! boolean CY;
              )
         
         ;
         end
      ; 
      event HES;
      end
   ; 
   process MEM_WITHOUT_DUPL =
        { MIN_A; }
        ( ? integer A;
          ! integer X; 
            integer Y; 
            boolean DIRECT_READ_ACCEPT; 
            boolean READ_ACCEPT;
        )
      (| (| X := A
          | (| X := Out
             | Y := X
             |) where integer X; end
          | (| In := X
             | MEM{MIN_A}
             |) where integer In; end
          | (| In := X
             | REQUEST{}
             |) where integer In; end
          |)/ Out |)
      where 
      process MEM =
           { V0; }
           ( ? In;
             ! Out;
           )
         (| M_In := In cell (^Out) init V0
          | Out := M_In when (^Out)
          |)
         where 
         M_In;
         end
      ; 
      process REQUEST =
           ( ? In; 
               Out;
             ! boolean DIRECT_READ_ACCEPT; 
               boolean READ_ACCEPT;
           )
         (| (| (| b := (^Out) default (not (^In)) default zb
                | zb := b$1 init true
                |)/ b
             | (| READ_ACCEPT := not zb
                | DIRECT_READ_ACCEPT := (^In) default READ_ACCEPT
                | Out ^= Out when DIRECT_READ_ACCEPT
                |)
             |)/ zb |)
         where 
         boolean no_duplication, b, zb;
         end
      ; 
      integer Out;
      end
   ; 
   process SCREEN =
        { integer TICK_NUMBER, FRONT_NUMBER, TICK_HEIGHT, DELTA, TICK_WIDTH, ESP_HEIGHT, STRING_HEIGHT, MIN_A, MAX_A; }
        ( ? event H_0; 
            event HVISU; 
            boolean C1; 
            boolean C2; 
            integer V1; 
            integer V2;
        )
      (| (| (| HE := HVISU
             | X := WSET{TICK_NUMBER, FRONT_NUMBER, 4*TICK_HEIGHT, DELTA+DELTA+TICK_WIDTH}(SCREEN, HE)
             |) where event HE; end
          | (| Z_V1 := V1$ init MIN_A
             | WINT{2*TICK_HEIGHT, TICK_HEIGHT, DELTA, TICK_WIDTH, MIN_A, MAX_A, STRING_HEIGHT}(SCREEN, Z_V1, V1, X)
             |)/ Z_V1
          | (| HE := HVISU
             | INITSCREEN{}
             |) where event HE; end
          | (| WBOOL{TICK_HEIGHT-(3*ESP_HEIGHT), TICK_HEIGHT, DELTA, TICK_WIDTH}(SCREEN, C1, X)
             | WBOOL{2*TICK_HEIGHT, TICK_HEIGHT, DELTA, TICK_WIDTH}(SCREEN, C2, X)
             |)
          | (| Z_V2 := V2$ init MIN_A
             | WINT{(3*TICK_HEIGHT)+(3*ESP_HEIGHT), TICK_HEIGHT, DELTA, TICK_WIDTH, MIN_A, MAX_A, STRING_HEIGHT}(SCREEN, Z_V2, V2, X)
             |)/ Z_V2
          |)/ SCREEN, X |)
      where 
      integer X, Z_V1, SCREEN, Z_V2;
      end
   ; 
   boolean DIRECT_READ_ACCEPT, READ_ACCEPT, C1, C2; 
   integer X, Y, A, V1, V2; 
   event H_0, HVISU;
   end
; 
