
FIND_PACKAGE(Java REQUIRED)
FIND_PACKAGE(JNI REQUIRED)

# Source 
SET(MOD_LIST
  mainSimu.java
  Simu${FOO}.java
  )

SET(clpath ${CMAKE_SOURCE_DIR}:"$ENV{SignalLib_Java}/SignalJavaStd.jar":"$ENV{pK_ROOT}")

SET(OUTPUT 
  ${CMAKE_SOURCE_DIR}/mainSimu.class
  ${CMAKE_SOURCE_DIR}/Simu${FOO}.class
  )

ADD_CUSTOM_COMMAND(
  OUTPUT ${OUTPUT}
  COMMAND ${CMAKE_COMMAND} -E remove -f ${CMAKE_SOURCE_DIR}/Direction.java
  COMMAND ${JAVA_COMPILE} ARGS ${MOD_LIST} -classpath ${clpath} -d ${CMAKE_SOURCE_DIR}
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
  DEPENDS ${MOD_LIST}
)

ADD_CUSTOM_TARGET(javacode ALL DEPENDS ${OUTPUT})

# Source C
SET(C_MOD_LIST
  ${FOO}_body.c
  ${FOO}_javaC.c
  e${FOO}.c
  )

SET_SOURCE_FILES_PROPERTIES(${C_MOD_LIST} PROPERTIES LANGUAGE CXX GENERATED true)

INCLUDE_DIRECTORIES("$ENV{SignalLibC_incl}")
INCLUDE_DIRECTORIES("$ENV{SignalLibJava_graphical}")
INCLUDE_DIRECTORIES("${JAVA_INCLUDE_PATH}")
INCLUDE_DIRECTORIES("${JAVA_INCLUDE_PATH2}")
SET(LIBRARY_OUTPUT_PATH ${CMAKE_SOURCE_DIR})
ADD_LIBRARY(Simu SHARED ${C_MOD_LIST})

# -------------------------
ADD_CUSTOM_TARGET(info ALL 
  COMMAND ${CMAKE_COMMAND} -E  echo "To execute, launch, in ${CMAKE_SOURCE_DIR} directory"
  COMMAND ${CMAKE_COMMAND} -E  echo "          java -classpath .:\${SignalLibJava_graphical}/SignalGraphicalJavaStd.jar mainSimu"
)
ADD_DEPENDENCIES(info javacode Simu)

