/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

static FILE *fwDUMPFILE_VCD_;

static int VCD_counter_ = 0;

#define LG_INT 64
static int t[LG_INT];

static void _int2bin_(int e1)
{
  unsigned long c,e; 
  int i; 
  for(i=LG_INT-1;i>=0;i--)  t[i]=0;
  
  i=0;
  e=e1;
  c=e/2;
  while(c != 0)
    {
      t[i]=e%2; 
      e=c;
      c=e/2;
      i++;
    }
  t[i]=e;
  //  printf(" _int2bin_, e1= %d, i = %d \n", e1, i );
}

static void print_VCD_float(float x)
{
  fprintf(fwDUMPFILE_VCD_,"r");
  fprintf(fwDUMPFILE_VCD_, "%f ", x);
}



static void print_VCD_int(int x)
{
  int i;
  _int2bin_(x);
  fprintf(fwDUMPFILE_VCD_,"b");
  for(i=LG_INT-1;i>=0;i--)
    fprintf(fwDUMPFILE_VCD_, "%d",t[i]);
  fprintf(fwDUMPFILE_VCD_," ");
}

static void print_VCD_logical(int x)
{
  fprintf(fwDUMPFILE_VCD_,"%d",x);
}

static void print_VCD_boolean(int x)
{
  print_VCD_logical(x);
}

static void print_VCD_double(double x)
{
  fprintf(fwDUMPFILE_VCD_,"r");
  fprintf(fwDUMPFILE_VCD_, "%lf ", x);
}

#define print_VCD_short(x) print_VCD_int((int) x)
#define print_VCD_long(x) print_VCD_int((int) x)

static int _cpt_step = 1;

static int 
isDecimalDigit(char c)
{
  return ((int) (((unsigned) c >= (unsigned) ('0')) && ((unsigned) c <= (unsigned) ('9'))));
}

static void VCD_setStep_()
{
  int i, b;
  char v[10];
  char c;

  if (_cpt_step == 1)
    {
      do 
	{
	  fprintf(stdout, "Number of Steps | q(uit) | c(ontinue): "); 
	  scanf("%s", &v);
	  c = v[0];
	  if (( c == 'q') || ( c == 'Q')) exit(0);
	  if (( c == 'c') || ( c == 'C')) 
	    _cpt_step = -1;
	  else
	    {
	      b = 1;
	      i = 0;
	      while (c != '\0' && b) 
		{ 
		  b = isDecimalDigit(c); 
		  i++;
		  c = v[i];
		}
	      if (b) _cpt_step = atoi(v); else _cpt_step = 0;
	    }
	}
      while (_cpt_step == 0);
    }
  else
    if (_cpt_step >0) _cpt_step--;
}

/**
   Inhibit the effect of the VCD_setStep() function.
*/
extern void _VCD_setContinueMode()
{
  _cpt_step = 0;
}
