module SIGALI_SYNTHESIS =

 pragmas 
      Comment " Sigali predefined library: SYNTHESIS "
   end pragmas
   process S_Security =
        ( ? setOfStates PROP;
          ! boolean RESULT;
        )
%       spec (| RESULT ^= PROP |) %
      pragmas 
         Sigali "S : &n(S, &i1);"
         Comment "S_Security(SYSTEM,SET)  -> SYSTEM  :  If  p encodes  a set  of  states E,"
                 "S_Security(S,p) computes a controller  that ensures  the invariance  of E function. "
      end pragmas

   %S_Security%; 
   process S_Reachable =
        ( ? setOfStates PROP;
          ! boolean RESULT;
        )
%       spec (| RESULT ^= PROP |) %
      pragmas 
         Sigali "S : &n(S, &i1);"
         Comment " S_Reachable(SYSTEM,SET)  -> SYSTEM :   If p  encodes a  set of  states E,"
                 " S_Reachable(S,p) computes a controller  that ensures the reachability of E"
                 " from  the initial  states  The controlled  system  is the  output of  this function. "
      end pragmas

   %S_Reachable%; 
   process S_Attractivity =
        ( ? setOfStates PROP;
          ! boolean RESULT;
        )
%       spec (| RESULT ^= PROP |) %
      pragmas 
        Sigali "S : &n(S, &i1);"
        Comment " S_Attractivity(SYSTEM,SET) -> SYSTEM  :  If p encodes a  set of states E,"
        " S_Attractivity(S,p) computes a controller that ensures the attractivity of"
        " E from  the initial  states The  controlled system is  the output  of this"
        " function."
      end pragmas

   %S_Attractivity%; 
   process S_Reachable_Secur =
        ( ? setOfStates PROP;
          ! boolean RESULT;
        )
%          spec (| RESULT ^= PROP |) %
      pragmas 
        Sigali "S : &n(S, &i1);"
         Comment "S_Reachable_Security(SYSTEM,SET)-> SYSTEM : If  p encodes a set of states"
                 " S_Attractivity(S,p)   computes  a  controller   that  first   ensures  the"
                 " invariance of E (computation of  the greatest invariant under U-control of"
                 " E, say F, and secondly that ensures the reachability of F from the initial"
                 " states.  The controlled system is the output of this function."
      end pragmas

   %S_Reachable_Secur%; 
   process S_Attractivity_Secur =
        ( ? setOfStates SET;
          ! boolean RESULT;
        )
%       spec (| RESULT ^= SET |)    %
      pragmas 
        Sigali "S : &n(S, &i1);"
         Comment "S_Reachable_Security(SYSTEM,SET)-> SYSTEM : If  p encodes a set of states"
                 " S_Attractivity(S,p)   computes  a  controller   that  first   ensures  the"
                 " invariance of E (computation of  the greatest invariant under U-control of"
                 " E, say F, and secondly that ensures the reachability of F from the initial"
                 " states.  The controlled system is the output of this function."
      end pragmas

   %S_Attractivity_Secur%;


end;
