module AADL_CONNECTION =

   process Connection =
     {type item_type;}
     (? item_type write_data; event Latency_time_event;
      ! item_type read_data;)
     pragmas
       Comment "It models the connection between two AADL processes."
          "These two AADL processes are bound to different processors."
          "A memory AT() is used to model the latency delay of the connection."
          "@parameter item_type: type of write_data and read_data"
          "@input write_data: write data of connection"
          "@input Latency_time_event: event of latency time"
          "@output read_data: the value of write_date at the event of Latency_time_event"
     end pragmas
     (| read_data := AT(write_data, Latency_time_event) |)
    ;
  
end;
  

