module AADL_PortConnectionINTERFACE =

use AADL_TYPE;

process Distributer_Broadcast = 
{integer Distributer_ID;}
(? i; ! o;) 
pragmas
       Comment "if 'Fan_Out_Policy' = 'Briadcast', the output is sent to all the connections which are associated to it "
end pragmas
  (|o := i
   |o ^= i
   |); 


process Distributer_OnDemand = 
{integer Distributer_ID;}
(? i; event demand; ! o;) 
pragmas
       Comment "if 'Fan_Out_Policy' = 'OnDemand', the output is sent to the connection (receiver) which requires for it "
end pragmas
  (|o := i when demand
   |); 


process Distributer_Selective =
{integer Distributer_ID;}
(? i; boolean select; ! o;)
pragmas
       Comment "if 'Fan_Out_Policy' = 'Selective', the output is sent to the connection (receiver) which is selected "
end pragmas
(|o := i when select
 |);



process Distributer_RoundRobin =
{integer Distributer_ID;}
(? i; integer RR_ID; ! o;)
pragmas
       Comment "if 'Fan_Out_Policy' = 'RoundRobin', the output is sent to the connection (receiver) whose Distributer_ID equals to the RR_ID "
end pragmas
(|o := i when (RR_ID = Distributer_ID)
 |);

process RoundRobin =
{integer m;}
(? event trigger; ! integer RR_ID;)
(| RR_ID := (zID+1) modulo m when trigger default zID
 | zID := RR_ID$1 init 0
 |)
where
  integer zID;
end;

end;
